<template>
  <div>
    <div class="container">
      <div class="containerElement containerElement1">
        <div v-if="attachmentExtension == 'image'">
          <img
            :src="post.attachment"
            class="containerElementImg"
            alt="image choisie par l'utilisateur pour illustrer son post"
          />
        </div>
        <div v-if="attachmentExtension == 'audio'">
          <audio :src="post.attachment" controls preload="none"></audio>
        </div>
        <div v-if="attachmentExtension == 'video'">
          <video :src="post.attachment" controls class="containerElementImg"></video>
        </div>
      </div>
      <div class="containerElement containerElement2">
        <p>Publié le {{ dateCreated(post.createdAt) }}</p>
        <h2>{{ post.title }}</h2>
        <p>{{ post.description }}</p>

        <!-- Zone des commentaires : saisie, affichage... -->
        <label></label>
        <textarea
          cols="90"
          rows="2"
          id="comment"
          name="comment"
          placeholder="Ajouter un commentaire ici"
          @focusin="cancelComment"
          v-model="description"
          required
        ></textarea>
        <button id="addComment" type="submit" @click="addComment(post.id)">
          Ajouter

          <font-awesome-icon icon="plus" />
        </button>
        <button id="cancelComment" @click="cancelComment">Annuler la saisie</button>
        <font-awesome-icon icon="text-slash" @click="cancelComment" />

        <button v-if="isVisibleComment == false" id="showComment" @click="showComment">
          Afficher les commentaires
        </button>
        <font-awesome-icon
          v-if="isVisibleComment == false"
          icon="comment"
          @click="showComment"
        />
        <button v-if="isVisibleComment == true" id="showComment" @click="showComment">
          Masquer les commentaires
        </button>
        <font-awesome-icon
          v-if="isVisibleComment == true"
          icon="comment-slash"
          @click="showComment"
        />
        <button v-if="userCanDeletePost == true" id="showComment" @click="deletePost(post.id)">Supprimer le post</button>
        <font-awesome-icon icon="trash" v-if="userCanDeletePost == true" @click="deletePost(post.id)" />
      </div>
    </div>
    <div v-if="isVisibleComment">
      <div
        class="containerComment"
        v-for="(comment, index) in comments"
        :comment="comment"
        :key="index"
      >
        <p>
          {{ comment.description }}
        </p>
        <button
          v-if="userCanDeleteComment == true"
          id="showComment"
          @click="deleteComment(comment.id)"
        >
          Supprimer le commentaire
        </button>
        <font-awesome-icon icon="trash" @click="deleteComment(comment.id)" />
      </div>
    </div>
    <div v-else>Comentaires...</div>
  </div>
</template>

<script>
import axios from "axios";
import { mapState } from "vuex";
import dayjs from "dayjs";
require("dayjs/locale/fr");
dayjs.locale("fr");

export default {
  name: "SinglePost",
  data() {
    return {
      isVisibleComment: false,
      description: "",
      comments: this.post.Comments,
      extension: "",
    };
  },
  props: {
    post: Object,
    deletePost: Function,
  },

  created() {},

  computed: {
    ...mapState(["status", "user"]),

    userCanDeleteComment() {
      const userId = this.$store.state.user.userId;
      const isAdmin = this.$store.state.user.isAdmin;
      if (this.post.Comments.userId !== userId && isAdmin == false) {
        return false;
      } else {
        return true;
      }
    },
      userCanDeletePost() {
      const userId = this.$store.state.user.userId;
      const isAdmin = this.$store.state.user.isAdmin;
      if (this.post.UserId !== userId && isAdmin == false) {
        return false;
      } else {
        return true;
      }
    },
    attachmentExtension() {
      if (this.post.attachment == null) {
        let extensionType = "";
        return extensionType;
      }

      let extension = this.post.attachment.split(".")[1];
      let extensionType = "";
      switch (extension) {
        case "jpg":
          extensionType = "image";
          break;
        case "jpeg":
          extensionType = "image";
          break;
        case "png":
          extensionType = "image";
          break;
        case "avi":
          extensionType = "video";
          break;
        case "mp4":
          extensionType = "video";
          break;
        case "gif":
          extensionType = "gif";
          break;
        case "mp3":
          extensionType = "audio";
          break;
        default:
          null;
      }
      return extensionType;
    },
  },

  methods: {
    //Ajouter un commentaire
    addComment(postId) {
      //const self = this;
      const token = this.$store.state.user.token;
      axios
        .post(
          "http://localhost:3000/api/comments/create",
          {
            description: this.description,
            PostId: postId,
          },
          {
            headers: { Authorization: `Basic ${token}` },
          }
        )
        .then(({ data }) => {
          this.comments = data.comments; // A revoir
          this.cancelComment();
          alert("Votre commentaire est créé");
        })
        .catch((error) => {
          console.log(error);
          alert("Publication commentaire impossible");
        });
    },

    //Effacer la saisie du commentaire - Non fonctionnel
    cancelComment() {
      this.description = "";
    },

    //Masquer les commentaires
    showComment() {
      if (this.isVisibleComment) {
        this.isVisibleComment = false;
      } else {
        this.isVisibleComment = true;
      }
    },

    //Supprimer un commentaire
    deleteComment(commentId) {
      const token = this.$store.state.user.token;
      const id = commentId;
      if (
        window.confirm(
          "Voulez-vous supprimez ce post ? Cette opération est irreversible. Les commentaires seront supprimés"
        )
      ) {
        axios
          .delete(`http://localhost:3000/api/comments/delete/${id}`, {
            headers: {
              Authorization: `Basic ${token}`,
            },
          })
          .then(({ data }) => {
            this.comments = data.comments; // A revoir
            alert("Votre commentaire est supprimé");
          })
          .catch((error) => {
            console.log(error);
            alert("Suppression impossible");
          });
      }
    },
    dateCreated(date) {
      return dayjs(date).format("dddd D MMMM YYYY", "fr");
    },
    //Obtenir les noms prénoms de post.userId
    getName(id) {
      const token = this.$store.state.user.token;
      let userPost = "";
      axios
        .get(`http://localhost:3000/api/users/one/${id}`, {
          headers: {
            Authorization: `Basic ${token}`,
          },
        })
        .then((response) => {
          userPost = response.data.firstName;
        })
        .catch((error) => {
          console.log(error);
        });

      return userPost;
    },
  },
};
</script>

<style lang="scss" scoped>

font-awesome-icon {
  cursor: pointer;
}
.container {
  display: flex;
  padding: 10px;
  margin: 20px;
  min-width: 900px;
  max-width: 1100px;
  min-height: 200px;
  background-color: rgb(255, 255, 255);
  color: rgba(0, 0, 0, 0.92);
  transition: box-shadow 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
  border-radius: 4px;
  box-shadow: rgb(0 0 0 / 20%) 0px 2px 1px -1px, rgb(0 0 0 / 14%) 0px 1px 1px 0px,
    rgb(0 0 0 / 12%) 0px 1px 3px 0px;
  &Element {
    &Img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
    &1 {
      width: 30%;
    }
    &2 {
      width: 70%;
      padding: 10px;
    }
  }
}
h3 {
  color: rgb(139, 55, 55);
}
button {
  border: none;
  border-radius: 10%;
  margin: 10px;
  cursor: pointer;
}
textarea {
  font-family: Monsterrat, Arial, sans-serif;
  border: none;
  border-bottom: 1px solid red;
  width: 90%;
}
.containerComment {
  padding: 10px;
  margin: 20px 20px 20px 40px;
  min-width: 700px;
  max-width: 1080px;
  //min-height: 200px;
  background-color: rgb(255, 255, 255);
  color: rgb(94, 5, 5);
  font-style: italic;
  transition: box-shadow 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
  border-radius: 4px;
  box-shadow: rgb(0 0 0 / 20%) 0px 2px 1px -1px, rgb(0 0 0 / 14%) 0px 1px 1px 0px,
    rgb(0 0 0 / 12%) 0px 1px 3px 0px;
}
@media screen and (max-width: 660px) {
  .container {
    flex-direction: column;
    min-width: 80%;
    max-width: 90%;
    min-height: 150px;
    &Element {
      &Img {
        width: 100%;
        height: 100%;
        object-fit: cover;
      }
      &1 {
        width: 100%;
      }
      &2 {
        width: 100%;
        padding: 10px;
      }
    }
  }
  textarea {
    width: 90%;
  }
}
</style>
